scala.tools.nsc.backend.icode.analysis

# CopyPropagation

#### abstract class CopyPropagation extends AnyRef

A modified copy-propagation like analysis. It is augmented with a record-like value which is used to represent closures.

Source
  CopyPropagation.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
copyPropagation
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. CopyPropagation
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new CopyPropagation()

### Type Members

1. #### case class Boxed(l: Location) extends Value with Product with Serializable

   The boxed value of some location.

2. #### case class Const(c: Global.Constant) extends Value with Product with Serializable

   The constant value c.

3. #### final class CopyAnalysis extends DataFlowAnalysis[copyLattice.type]

4. #### case class Deref(l: Location) extends Value with Product with Serializable

   The value of some location in memory.

5. #### case class Field(r: Record, sym: Global.Symbol) extends Location with Product with Serializable

6. #### case class LocalVar(l: Global.icodes.Local) extends Location with Product with Serializable

7. #### sealed abstract class Location extends AnyRef

   Locations can be local variables, this, and fields.

8. #### case class Record(cls: Global.Symbol, bindings: Map[Global.Symbol, Value]) extends Value with Product with Serializable

9. #### sealed abstract class Value extends AnyRef

   Values that can be on the stack.

### Abstract Value Members

1. #### abstract val global: Global

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from CopyPropagation to any2stringadd[CopyPropagation] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (CopyPropagation, B)

   Implicit information
     This member is added by an implicit conversion from CopyPropagation to ArrowAssoc[CopyPropagation] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### object AllRecords extends Record

   The bottom record.

7. #### object This extends Location with Product with Serializable

8. #### object Unknown extends Value with Product with Serializable

   Unknown.

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### object copyLattice extends SemiLattice

    The lattice for this analysis.

12. #### def ensuring(cond: (CopyPropagation) ⇒ Boolean, msg: ⇒ Any): CopyPropagation

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to Ensuring[CopyPropagation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (CopyPropagation) ⇒ Boolean): CopyPropagation

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to Ensuring[CopyPropagation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): CopyPropagation

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to Ensuring[CopyPropagation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): CopyPropagation

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to Ensuring[CopyPropagation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

19. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to StringFormat[CopyPropagation] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

20. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

21. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

22. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

23. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

24. #### final def notify(): Unit

    Definition Classes
      AnyRef

25. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toString(): String

    Definition Classes
      AnyRef → Any

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

30. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### def →[B](y: B): (CopyPropagation, B)

    Implicit information
      This member is added by an implicit conversion from CopyPropagation to ArrowAssoc[CopyPropagation] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from CopyPropagation to any2stringadd[CopyPropagation]

### Inherited by implicit conversion StringFormat from CopyPropagation to StringFormat[CopyPropagation]

### Inherited by implicit conversion Ensuring from CopyPropagation to Ensuring[CopyPropagation]

### Inherited by implicit conversion ArrowAssoc from CopyPropagation to ArrowAssoc[CopyPropagation]

### Ungrouped